package simapclient;


import java.util.ArrayList;

import org.apache.axis2.om.OMAttribute;
import org.apache.axis2.om.OMElement;

public class HitProtein {
	
	private ArrayList<HitTaxNode> taxonomy;
	private String linkoutUrl;
	private String description;
	private String title;
	private int tax_node;

	private int database_id;
	
	private String database_name;
	private String database_description;
	private String source_type;
	private int sequence_length;
	private int sequence_id;
	private String is_public;
	private String is_outdated;
	
	public void setSequenceId(int id){
		this.sequence_id=id;
	}
	public static  HitProtein parse(OMElement xml){
		HitProtein result=new HitProtein();
		result.taxonomy=new ArrayList();
		ArrayList<OMAttribute> attr=SimapClientUtil.fromIterator(xml.getAllAttributes());
		for (OMAttribute a : attr){
			if (a.getLocalName().equalsIgnoreCase("description")) result.description=a.getAttributeValue();
			if (a.getLocalName().equalsIgnoreCase("name")) result.title=a.getAttributeValue();
			if (a.getLocalName().equalsIgnoreCase("public")) result.is_public=a.getAttributeValue();
			if (a.getLocalName().equalsIgnoreCase("outdated")) result.is_outdated=a.getAttributeValue();
			if (a.getLocalName().equalsIgnoreCase("taxonomyId")) result.tax_node=new Integer(a.getAttributeValue()).intValue();
		}
		ArrayList<OMElement> children=SimapClientUtil.fromIterator(xml.getChildElements());
		
		for (OMElement c:children)	{
			if (c.getLocalName().equalsIgnoreCase("linkouturl")) {
		
				result.linkoutUrl=c.getText();
			
			
			}
			if (c.getLocalName().equalsIgnoreCase("taxonomyNode")){
				ArrayList<OMElement> abstammung=SimapClientUtil.fromIterator(c.getChildElements());
				
				result.taxonomy.add(HitTaxNode.parse(c));
				for (int i=abstammung.size()-1;i>=0;i--) {
					
					result.taxonomy.add(HitTaxNode.parse(abstammung.get(i)));
				}
			}
			if (c.getLocalName().equalsIgnoreCase("database")){
				ArrayList<OMAttribute> database = SimapClientUtil.fromIterator(c.getAllAttributes());
				for (OMAttribute dba:database){
					if (dba.getLocalName().equalsIgnoreCase("description")) result.database_description=dba.getAttributeValue();
					if (dba.getLocalName().equalsIgnoreCase("name")) result.database_name=dba.getAttributeValue();
					if (dba.getLocalName().equalsIgnoreCase("databaseId")) result.database_id=new Integer(dba.getAttributeValue()).intValue();
					if (dba.getLocalName().equalsIgnoreCase("sourceType")) result.source_type=dba.getAttributeValue();
					
					
				}
				
			}
			
			
			
		}
			
		
		
		
		
	
		return result;
		
	}
	
	
	public String toString() {
		//if (1==1)return "";
		StringBuffer str=new StringBuffer();
		str.append("title:\t"+this.getTitle()+"\n");
		str.append("descr:\t"+this.getDescription()+"\n");
		str.append("URL:\t"+this.getLinkoutUrl()+"\n");
		str.append("tax_node(NCBI)\t"+this.getTax_node()+"\n");
		
		str.append("Taxonomy:\t"+this.getTaxonomy()+"\n");
		
		str.append("Internal database-id\t"+this.getDatabase_id()+"\n");
		str.append("Source type:\t"+this.getSource_type()+"\n");
		str.append("Database name:\t"+this.getDatabase_name()+"/\t"+this.getDatabase_description()+" Type: "+this.source_type+"\n");
		str.append("Link Out: \t"+this.linkoutUrl+"\n");
		
		str.append("Taxonomy:\t"+this.taxonomy);
		
		
		
		return str.toString();
	}
	
	
	public String getDescription() {
		return description;
	}
	
	
	public String getLinkoutUrl() {
		return linkoutUrl;
	}

	
	
	public int getTax_node() {
		return tax_node;
	}
	
	
	public ArrayList<HitTaxNode> getTaxonomy() {
		return taxonomy;
	}
	
	
	public String getTitle() {
		return title;
	}
	
	
	public int getDatabase_id() {
		return database_id;
	}
	
	
	public String getDatabase_name() {
		return database_name;
	}
	
	public String getDatabase_description() {
		return database_description;
	}

	public String getSource_type() {
		return source_type;
	}
	
	
	public int getSequence_length() {
		return sequence_length;
	}
	
	
	public int getSequence_id() {
		return sequence_id;
	}
	
}
