package simapclient;


import java.util.ArrayList;
import java.util.Iterator;

import org.apache.axis2.om.OMAttribute;
import org.apache.axis2.om.OMElement;

public class HitSequence {
	private int sequence_id;
	private int selfscore;
	private String md5;
	private String sequence;
	
	private int length;
	private int number_hits;
	private ArrayList<HitProtein> proteins;
	public int getLength() {
		return length;
	}
	public String getMd5() {
		return md5;
	}
	public int getNumber_hits() {
		return number_hits;
	}
	public int getSelfscore() {
		return selfscore;
	}
	public String getSequence() {
		return sequence;
	}
	public int getSequence_id() {
		return sequence_id;
	}
	public ArrayList<HitProtein> getProteins() {
		return proteins;
	}
	public static HitSequence parse(OMElement xml){
		HitSequence result=new HitSequence();
		result.proteins=new ArrayList();
		ArrayList<OMAttribute> hit_props=SimapClientUtil.fromIterator(xml.getAllAttributes());
		for (OMAttribute prop: hit_props){
			if (prop.getLocalName().equalsIgnoreCase("selfscore")) {
				result.selfscore=new Integer(prop.getAttributeValue()).intValue();
			}
			if (prop.getLocalName().equalsIgnoreCase("sequenceid")) {
				result.sequence_id=new Integer(prop.getAttributeValue()).intValue();
			}
			if (prop.getLocalName().equalsIgnoreCase("md5")) {
				result.md5=prop.getAttributeValue();	
			}
			if (prop.getLocalName().equalsIgnoreCase("number_hits")) {
				result.number_hits=new Integer(prop.getAttributeValue()).intValue();
			}
			if (prop.getLocalName().equalsIgnoreCase("length")) {
				result.length=new Integer(prop.getAttributeValue()).intValue();
			}
			
		}
		ArrayList <OMElement> children=SimapClientUtil.fromIterator(xml.getChildElements());
		for (OMElement elem: children){
			
			
			
			
			if (elem.getLocalName().equalsIgnoreCase("sequence")){
				// get sequence
				Iterator i=elem.getChildElements();
				if (i.hasNext())
				result.sequence=((OMElement)i.next()).getText();
				// get sequence attributes
				ArrayList<OMAttribute> attr=SimapClientUtil.fromIterator(elem.getAllAttributes());
				for (OMAttribute a:attr){
					
					if (a.getLocalName().equalsIgnoreCase("number_hits")){
						if (!(a.getAttributeValue().equalsIgnoreCase("unknown"))) {
							result.number_hits=new Integer(a.getAttributeValue()).intValue();
						} else {
							result.number_hits=-1;
						}
					}
				}
				
			}
			// create protein instances
			if (elem.getLocalName().equalsIgnoreCase("protein")){
				HitProtein prot=HitProtein.parse(elem);
				
				
				prot.setSequenceId(result.sequence_id);
				result.proteins.add(prot);
				
			}
		}
		
		return result;
	}
	
	public String toString() {
		StringBuffer res=new StringBuffer();
		res.append("HitSequence\n");
		res.append("Sequence_id\t"+this.sequence_id+"\n");
		res.append("md5\t"+this.md5+"\n");
		res.append("selfscore\t"+this.selfscore+"\n");
		res.append("length\t"+this.length+"\n");
		res.append("amount hits\t"+this.number_hits+"\n");
		res.append("Sequence\n"+this.sequence+"\n");
		res.append("protein instances:\n"+this.proteins);
		return res.toString();
	}
	
}


