package simapclient;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Hashtable;

public interface SimapAccess {

	/**
	 private  String getHitsByMultipleDatabaseQuery(int[] queryDatabaseIDs,
	 int[] dbDatabaseIDs, int searchmode, boolean check_bbh) {
	 asyncSimap.getHitsByMultipleDatabaseQuery(queryDatabaseIDs,
	 dbDatabaseIDs,this.show_non_public,this.show_outdated,searchmode,this.max_number_hits,this.min_swscore,this.max_evalue,check_bbh);
	 return (String) execute((AsynchProvider)asyncSimap);
	 
	 }
	 **/

	/* (non-Javadoc)
	 * @see simap.SimapAccess#getSequenceIdsByDatabase(java.lang.String)
	 */
	public abstract ArrayList<Integer> getSequenceIDsByDatabase(int database_id);
	
	public abstract ArrayList<String> getProteinNamesByDatabase(int database_id);
	
	/* (non-Javadoc)
	 * @see simap.SimapAccess#computeMD5(java.lang.String)
	 */
	public abstract String computeMD5(String sequence) throws Exception;

	/* (non-Javadoc)
	 * @see simap.SimapAccess#getSeqidByMD5(java.lang.String)
	 */
	

	public abstract String getHitsXML() throws Exception;

	/* (non-Javadoc)
	 * @see simap.SimapAccess#getSequence(int)
	 */
	public abstract SingleSequence getSequence(int sequence_id);

	
	public abstract Protein getProtein(String md5) throws Exception;

	public abstract Collection<Hashtable> getAllDatabases() throws Exception ;

	/**TODO
	 * 
	 * @param source
	 * @return description string of a source id as "GenRE" or "PDB"
	 */
	

	/* (non-Javadoc)
	 * @see simap.SimapAccess#getDatabase(int)
	 */
	public abstract DataSet getDatabase(int database_id) throws Exception ;

	/* (non-Javadoc)
	 * @see simap.SimapAccess#getDatabase_list()
	 */
	

	/* (non-Javadoc)
	 * @see simap.SimapAccess#getMax_evalue()
	 */
	public abstract double getMax_evalue();

	/* (non-Javadoc)
	 * @see simap.SimapAccess#setMax_evalue(double)
	 */
	public abstract void setMax_evalue(double max_evalue);

	/* (non-Javadoc)
	 * @see simap.SimapAccess#getMax_number_hits()
	 */
	public abstract int getMax_number_hits();

	/* (non-Javadoc)
	 * @see simap.SimapAccess#setMax_number_hits(int)
	 */
	public abstract void setMax_number_hits(int max_number_hits);

	/* (non-Javadoc)
	 * @see simap.SimapAccess#getMin_swscore()
	 */
	public abstract int getMin_swscore();

	/**
	 * Set the score cut-off
	 * @param min_swscore void
	 *
	 */
	public abstract void setMin_swscore(int min_swscore);

	/* (non-Javadoc)
	 * @see simap.SimapAccess#sequences()
	 */
	public abstract boolean sequences();

	/* (non-Javadoc)
	 * @see simap.SimapAccess#sequences(boolean)
	 */
	public abstract void sequences(boolean o_sequences);

	/* (non-Javadoc)
	 * @see simap.SimapAccess#getSequence_id()
	 */
	public abstract int getSequence_id();

	/* (non-Javadoc)
	 * @see simap.SimapAccess#setSequence_id(int)
	 */
	public abstract void setSequence_id(int sequence_id);

	/**
	 * returns, whether private data should be presented in the results. (BE CAREFULL WITH THAT !)
	 * @return boolean
	 *
	 */


	

	/* (non-Javadoc)
	 * @see simap.SimapAccess#getTaxon_exclude()
	 */
	public abstract int[] getTaxon_exclude();

	public abstract void setTaxon_exclude(int[] taxon_exclude);

	/* (non-Javadoc)
	 * @see simap.SimapAccess#getTaxon_include()
	 */
	public abstract int[] getTaxon_include();

	/* (non-Javadoc)
	 * @see simap.SimapAccess#setTaxon_include(int[])
	 */
	public abstract void setTaxon_include(int[] taxon_include);

	/* (non-Javadoc)
	 * @see simap.SimapAccess#getTitle()
	 */
	public abstract String getTitle();

	/* (non-Javadoc)
	 * @see simap.SimapAccess#setTitle(java.lang.String)
	 */
	public abstract void setTitle(String title);


	/* (non-Javadoc)
	 * @see simap.SimapAccess#addDatabase(int)
	 */
	public abstract void addDatabase(int db);

	/* (non-Javadoc)
	 * @see simap.SimapAccess#addSource(int)
	 */
	public abstract void addSource(int src);

	/* (non-Javadoc)
	 * @see simap.SimapAccess#excludeTaxon(int)
	 */
	public abstract void excludeTaxon(int db);

	/* (non-Javadoc)
	 * @see simap.SimapAccess#includeTaxon(int)
	 */
	public abstract void includeTaxon(int db);

	/* (non-Javadoc)
	 * @see simap.SimapAccess#removeSource(int)
	 */
	public abstract void removeSource(int src);

	/* (non-Javadoc)
	 * @see simap.SimapAccess#removeDatabase(int)
	 */
	public abstract void removeDatabase(int db);

	/* (non-Javadoc)
	 * @see simap.SimapAccess#getSource_list()
	 */
	public abstract int[] getSource_list();

	/* (non-Javadoc)
	 * @see simap.SimapAccess#setSource_list(int[])
	 */
	public abstract void setSource_list(int[] source_list);

	
}