package simapclient;


import java.util.ArrayList;
import java.util.Collection;
import java.util.Hashtable;





/**
 * @author arnold
 *
 */
public class SimapAccessWebserviceImplAxis121  implements SimapAccess {

	private boolean show_outdated;
	private boolean show_non_public;
	 private String Title="";
     private int sequence_id;
     private String md5="";
     private int max_number_hits=300;
     private int min_swscore=10;
     private double max_evalue=100;
     private int[] taxon_include=new int[0];
     private int[] taxon_exclude=new int[0];
     private int[] database_list=new int[0];
     private int[] source_list=new int[0];
     
     private boolean o_sequences=false;
     private boolean o_alignments=false;
     private String XML_indent=" ";
     private boolean XML_newlines=true;
     private String XML_encoding="UTF-8";
     public SimapClient simap;
     public static final String AXIS2_HOME = null;
     
     
     public void setProxy(String host,String port){
 		simap.setProxy(host,port);
 	}
     /**
      * Use this constructor if You want to employ a different target endpoint
      * @param targetEndpoint
      * @throws java.lang.Exception
      */
     public SimapAccessWebserviceImplAxis121(String targetEndpoint) throws java.lang.Exception{
    	 simap=new SimapClient(targetEndpoint);
     }
     /**
      * Constructor using the standard target endpoint http://mips.gsf.de/webservices/services/simap
      * @throws java.lang.Exception
      */
     public SimapAccessWebserviceImplAxis121() throws java.lang.Exception {
         
         
         this("http://mips.gsf.de/webservices/services/SimapService");
    
         
     }

     
    public boolean showOutdated() {
    	return this.show_outdated;
    }

    //TODO
    public ArrayList<Integer>getSequenceIDsByDatabase(int database_id){
    	return null;
    }
    //TODO
    public ArrayList<String>getProteinNamesByDatabase(int database_id){
    	return null;
    }
    
    
    public  ArrayList<Hashtable> getAllDatabases() throws Exception {
    	
    	ArrayList<Hashtable> y=simap.getAvailableDatabases();
    	return y;
    }
    
    //TODO
    public DataSet getDatabase(int database_id){return null;}
    //TODO
	public String computeMD5(String sequence) throws Exception {
		return SimapClientUtil.computeMD5Hash(sequence);
	}
	//TODO
	public SingleSequence getSequence(int seq_id){return null;}
	
	private String[] mSA(int [] a){
		String[] h=new String[a.length];
		int i=0;
		for (int b: a) {
			h[i]=new String(new Integer(b).toString());
			  i++;
		}
		return h;
	}

	public boolean show_non_public() {return this.show_non_public;}
	public void showOutdated(boolean x){
		this.show_outdated=x;
		
	}
	
		/**
	 * returns a protein object using the md5 key.
	 * It contains the sequence information as well as a list of individual instances in different databases.
	 * @param md5
	 * @return Protein
	 *
	 */
	
	public Protein getProtein (String md5)throws Exception {
		ArrayList<Hashtable> r=this.simap.getProteinByMD5(md5);
		Protein g=new Protein(0);
		
		for (Hashtable o : r){
			Database db=new Database(
					
					(new Integer((String)o.get("db_id"))).intValue(),
							(String)o.get("db_name"),
							"");
							
				ProteinEntry instance=
				new ProteinEntry(db,
						(String)o.get("Title"),
						(String)o.get("Descr"),
						(new Integer(
								(String)o.get("tax_id")
								).intValue()
							),
						
							(new Integer((String)o.get("selfscore"))).intValue(),
							(new Integer((String)o.get("length"))).intValue()
							, (String)o.get("md5")
				);
				
			g.addInstance(instance);
		}
		
		return g;
	}
	
	
	
	
	/**
	 * Returns a XML representation of the query result. It can be parsed using the ResultParser class.
	 * The query parameters must be set by the appropriate methods before invoking the method.
	 * For details see the example program Example.java 
	 * @return String
	 *
	 */
	
	public String getHitsXML() throws Exception {
		
			
			return simap.getHitsByMD5(
				this.md5,
				mSA(this.taxon_include),
				mSA(this.taxon_exclude),
				mSA(this.source_list),
				this.min_swscore,
				new Double(this.max_evalue),
				this.max_number_hits,
				mSA(this.database_list),
				this.sequences(),
				this.alignments()).toString();
	
	}
	
	/**
	 * returns a query result in BLASTML format.
	 * @return String
	 *
	 */
	
	public String getHitsByMD5BLASTML() throws Exception {
	
			String m="<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<!DOCTYPE BlastOutput PUBLIC \"-//NCBI//NCBI BlastOutput/EN\" \"NCBI_BlastOutput.dtd\">\n";
			return m+simap.getHitsByMD5BLASTML(
				this.md5,
				mSA(this.taxon_include),
				mSA(this.taxon_exclude),
				mSA(this.source_list),
				this.min_swscore,
				new Double(this.max_evalue),
				this.max_number_hits,
				mSA(this.database_list),
				this.sequences(),
				this.alignments()).toString();
	
	}
	
	
	/**
	 * returns the id-list of the activated databases. If this list is empty, the whole SIMAP is queried.
	 */
	public int[] getDatabase_list() {
		
		return this.database_list;
	}

	/**
	 * set a database-id list to define a search-space
	 */
	public void setDatabase_list(int[] database_list) {
		this.database_list=database_list;

	}

	/**
	 * returns the Evalue cut-off currently set
	 */
	public double getMax_evalue() {
		
		return this.max_evalue;
	}

	/**
	 * set a E-Value cut-off
	 * 
	 */
	public void setMax_evalue(double max_evalue) {
		this.max_evalue=max_evalue;

	}

	/**
	 * returns the maximum numbers of hits
	 */
	public int getMax_number_hits() {
		return this.max_number_hits;
	}

	/**
	 * set the maximum number of hits in the resultlist
	 * This can be used to implement "return the 20 best hits only"
	 */
	public void setMax_number_hits(int max_number_hits) {
		this.max_number_hits=max_number_hits;

	}

	/**
	 * return the alignment score cut-off
	 * 
	 */
	public int getMin_swscore() {
		return this.min_swscore;
	}

	/**
	 * if this is set 'true', the alignments are recalculated and their topology is also returned in the result
	 * 
	 */
	public boolean alignments() {
		return this.o_alignments;
		
	}

	/**
	 * switch on/off the recomputation of alignments 'on-the-fly'
	 */
	public void alignments(boolean o_alignments) {
		this.o_alignments=o_alignments;

	}

	/**
	 * set the database list to null. This results in querying the whole SIMAP, if not otherwise confined.
	 */
	public void removeAllDatabases() {
		this.database_list=null;

	}
	/**
	 * if set to true, the sequences are also returned in the resultlists
	 */
	public boolean sequences() {
		return this.o_sequences;
	}

	/**
	 * switch on/off whether to return the sequences in the resultlists
	 */
	public void sequences(boolean o_sequences) {
		this.o_sequences=o_sequences;

	}

	/**
	 * return the actual sequence-id
	 * if a md5 is used to query SIMAP, then no sequence_id should be set!
	 */
	public int getSequence_id() {
		return this.sequence_id;
	}

	/**
	 * set the sequence-id for which to query SIMAP. Do not set if You use the md5-key instead (recommended) 
	 */
	public void setSequence_id(int sequence_id) {
		this.sequence_id=sequence_id;
	}

	/**
	 * get the taxons, which are deactivated at the moment. If the list is empty, no restrictions will be applied.
	 */
	public int[] getTaxon_exclude() {
		return this.taxon_exclude;
	}


	/**
	 * get the taxons, which are activated at the moment. If the list is empty, no restrictions will be applied.
	 */
	public int[] getTaxon_include() {
		return this.taxon_include;
	}

	/**
	 * set a list of taxons to include. 
	 * @param a list of NCBI taxonomy ids, e.g. [2] for bacteria.
	 */
	public void setTaxon_include(int[] taxon_include) {
		this.taxon_include=taxon_include;

	}

	/**
	 * returns a title of the search, which can be specified by the user
	 */
	public String getTitle() {
		return this.Title;
	}

	/**
	 * set a title to the query
	 */
	public void setTitle(String title) {
		this.Title=title;

	}

	/**
	 * include a certain dataset using a database-id. If nothing is set, all datasets are activated.
	 * As soon as one is set, only the activated list is used.
	 */
	public void addDatabase(int db) {
		if (this.database_list==null) this.database_list=new int[0];
        int[] n=new int[this.database_list.length+1];

        for (int i=0;i<this.database_list.length;i++) {
                        n[i]=this.database_list[i];
                        if (this.database_list[i]==db) return;
        }
        n[this.database_list.length]=db;
        this.database_list=n;




	}

	/**
	 * restrict the search to ceratin sources
	 * the sources are listed in the ResourceType class.
	 * 
	 */
	public void addSource(int src) {
	 	if (this.source_list==null) this.source_list=new int[0];
        int[] n=new int[this.source_list.length+1];

        for (int i=0;i<this.source_list.length;i++) {
                        n[i]=this.source_list[i];
                        if (this.source_list[i]==src) return;
        }
        n[this.source_list.length]=src;
        this.source_list=n;
	}

	/**
	 * remove a taxon from the list. This is provided to enable queries as 'all bacteria except E. coli'
	 */
	public void excludeTaxon(int db) {
		if (this.taxon_exclude==null) this.taxon_exclude=new int[0];
        int[] n=new int[this.taxon_exclude.length+1];

        for (int i=0;i<this.taxon_exclude.length;i++) {
                        n[i]=this.taxon_exclude[i];
                        if (this.taxon_exclude[i]==db) return;
        }
        n[this.taxon_exclude.length]=db;
        this.taxon_exclude=n;

	}
	/**
	 * include a taxon
	 */
	public void includeTaxon(int db) {
		if (this.taxon_include==null) taxon_include=new int[0];
        int[] n=new int[this.taxon_include.length+1];
     

        for (int i=0;i<this.taxon_include.length;i++) {
                        n[i]=this.taxon_include[i];
                        if (this.taxon_include[i]==db) {
                        	this.taxon_include=n;
                        	return;
                        }
        }
        n[this.taxon_include.length]=db;
        
        this.taxon_include=n;

	}

	/**
	 * remove a source from the source list
	 */
	public void removeSource(int src) {
		int[] n=new int[this.source_list.length-1];
        int u=0;
        for (int i=0;i<this.source_list.length;i++) {
                        if (!(this.source_list[i]==src)) n[u++]=this.source_list[i];;
        }

        this.source_list=n;

	}

	/**
	 * remove a dataset from the database list
	 */
	public void removeDatabase(int db) {
		 int[] n=new int[this.database_list.length-1];
         int u=0;
         for (int i=0;i<this.database_list.length;i++) {
                         if (!(this.database_list[i]==db)) n[u++]=this.database_list[i];;
         }

         this.database_list=n;

	}
	 public String toString() {
         StringBuffer res=new StringBuffer();
         res.append("sequence id:"+this.sequence_id+"\n");
         res.append("Used Databases:\n");
         for (int i=0;i<this.database_list.length;i++) {
                 res.append(this.database_list[i]);
                 if (i%15==0) {res.append("\n");} else {res.append("\t");}

         }
         res.append("\n");
         if (this.taxon_exclude.length==0) {res.append("Taxon excluded:" + "None\n");} else {res.append("Taxon included:" + this.taxon_include+"\n");}
         if (this.taxon_exclude.length==0) {res.append("Taxon excluded:" + "None\n");} else {res.append("Taxon excluded:" + this.taxon_exclude+"\n");}
         res.append("Evalue Cut-Off:"+this.getMax_evalue()+"\n");
         res.append("Score Cut-Off:"+this.getMin_swscore()+"\n");
         res.append("Maximal Amount of Hits:"+this.getMax_number_hits()+"\n");
         return res.toString();
 }
	/**
	 * return a list of activated databases/datasets
	 */
	public int[] getSource_list() {
		return this.source_list;
	}

	/**
	 * set a list of databases
	 */
	public void setSource_list(int[] source_list) {
		this.source_list=source_list;

	}

	

	/* (non-Javadoc)
	 * @see simap.SimapAccess#findSequenceXML(java.lang.String, boolean, int)
	 */
	public String findSequenceXML(String sequence,
			boolean search_complete_query, int max_number_hits) {
		// TODO Auto-generated method stub
		return null;
	}

	public ArrayList getSimilarSequences(String sequence, int max)throws Exception{
		
		return simap.getSimilarSequences(sequence,max);
		
	}
	/**
	 * return the currently used md5 if set
	 * @return String
	 *
	 */
	public String getMd5() {
		return md5;
	}
	/**
	 * set a md5 as query. Recommended over setting an sequence-id
	 * @param md5 void
	 *
	 */
	public void setMd5(String md5) {
		this.md5 = md5;
	}
	/**
	 * set a minimum alignment score cut-off
	 * @param min_swscore void
	 *
	 */
	public void setMin_swscore(int min_swscore) {
		this.min_swscore = min_swscore;
	}
	
	public static void main (String[] args){
		try {
			SimapAccessWebserviceImplAxis121 simap=new SimapAccessWebserviceImplAxis121("http://mips.gsf.de/webservices/services/SimapService");
			System.out.println(simap.getAllDatabases());
			System.exit(0);
			System.out.println(simap.getProtein("d4e9f53b5e73610ac17922f3ca4d0048"));
			//System.out.println(simap.getSimilarSequences("MPPSILVSSHDLARLEAMLESSalnnhpaaaalaDELGRARVVPPDQIPGD",5));
			simap.setMd5("d4e9f53b5e73610ac17922f3ca4d0048");
			simap.setMax_evalue(0.0001);
			System.out.println(simap.getHitsXML());
		} catch (Exception e){
			e.printStackTrace();
			
		}
	}
	public boolean isO_alignments() {
		return o_alignments;
	}
	public void setO_alignments(boolean o_alignments) {
		this.o_alignments = o_alignments;
	}
	public boolean isO_sequences() {
		return o_sequences;
	}
	public void setO_sequences(boolean o_sequences) {
		this.o_sequences = o_sequences;
	}
	public String getXML_encoding() {
		return XML_encoding;
	}
	public void setXML_encoding(String xml_encoding) {
		XML_encoding = xml_encoding;
	}
	public String getXML_indent() {
		return XML_indent;
	}
	public void setXML_indent(String xml_indent) {
		XML_indent = xml_indent;
	}
	public boolean isXML_newlines() {
		return XML_newlines;
	}
	public void setXML_newlines(boolean xml_newlines) {
		XML_newlines = xml_newlines;
	}
	public void setTaxon_exclude(int[] taxon_exclude) {
		this.taxon_exclude = taxon_exclude;
	}

}
