package simapclient;


import java.util.ArrayList;
import java.util.Hashtable;

import org.apache.axis.utils.XMLUtils;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

public class SimapClient {
	
	private SimapInvoker simap; 
	private String endpoint;
	private SimapHelper helper;
	
	public SimapClient(String uri) throws Exception{
			
			this.simap=new SimapInvoker();
			endpoint=uri;
			helper=new SimapHelper("http://mips.gsf.de/simap");
	}
	public  SimapClient() throws Exception{	
		helper=new SimapHelper("http://mips.gsf.de/simap");
			this.simap=new SimapInvoker();
			endpoint="http://mips.gsf.de/webservices/services/SimapService";
		
	}
	
	public void setProxy(String host,String port){
		helper.setProxy(host,port);
	}
	
	public ArrayList getSimilarSequences(String sequence, int max) throws Exception {
		Hashtable j=new Hashtable();
		ArrayList res=new ArrayList();
		j.put("sequence",sequence);
		j.put("max",max);
		Element query=helper.createElement("getSimilarSequences",j);
		Element r=helper.requestWebService(query,this.endpoint);
		NodeList dbs=r.getChildNodes();
		int u=dbs.getLength();
		for (int i=0;i<u;i++){
			Element cur=(Element)dbs.item(i);
			res.add(cur.getTextContent());
		}
		return res;
	}
	
	
	public String getMD5BySequence(String sequence) throws Exception {
		Hashtable j=new Hashtable();
		j.put("sequence",sequence);
		Element query=helper.createElement("getMD5BySequence",j);
		Element r=helper.requestWebService(query,this.endpoint);
		Hashtable b=helper.createHash(r);
		return (String)b.get("md5");
	}
	
	public ArrayList <Hashtable> getAvailableDatabases() throws Exception {
		ArrayList <Hashtable> res=new ArrayList();
		
		Element query=helper.createElement("getAvailableDatabases2");
		Element r=helper.requestWebService(query,this.endpoint);
		NodeList dbs=r.getChildNodes();
		int u=dbs.getLength();
		for (int i=0;i<u;i++){
			Element cur=(Element)dbs.item(i);
			
			Hashtable re=helper.createHash(cur);
			res.add(re);
		}
		
		
		
		//return (SimapDB[])res.toArray();
		return res;
	}
	
	public ArrayList <Hashtable> getProteinByMD5(String md5) throws Exception {
		ArrayList <Hashtable> res=new ArrayList();
		Hashtable t=new Hashtable();
		t.put("md5",md5);
		Element query=helper.createElement("getProteinByMD5",t);
		Element r=helper.requestWebService(query,this.endpoint);
		NodeList dbs=r.getChildNodes();
		int u=dbs.getLength();
		for (int i=0;i<u;i++){
			Element cur=(Element)dbs.item(i);
			
			Hashtable re=helper.createHash(cur);
			res.add(re);
			
		}
		
		
		
	
		return res;
	}
	
	
	public String getHitsByMD5
	(String md5, String[] taxonInclude, String[] taxonExclude, String[] sources, int min_optscore,
			Double maxEvalue,int maxNumberHits,String[] dbList, boolean show_sequence,boolean show_alignment) throws Exception {
		Hashtable<String,String> options=new Hashtable();
		
		options.put("md5",md5);
	
		options.put("showSequence",new Boolean(show_sequence).toString());
		options.put("showAlignment",new Boolean(show_alignment).toString());
		options.put("maxNumberHits",new Integer(maxNumberHits).toString());
		options.put("maxEvalue",new Double(maxEvalue).toString());
		options.put("minSWScore",new Integer(min_optscore).toString());
		//options.put("dbList",dbList);
		
		Element query=helper.createElement("getHitsByMD5",options);
		
		Element dbs=helper.createListElement("DatabaseList","database",dbList);
		query.appendChild(dbs);
		
		Element source_include=helper.createListElement("sourceList","source",sources);
		query.appendChild(source_include);
		
		
		Element tax_include=helper.createListElement("TaxonsInclude","taxId",taxonInclude);
		query.appendChild(tax_include);
		
		Element tax_exclude=helper.createListElement("TaxonsExclude","taxId",taxonExclude);
		
		query.appendChild(tax_exclude);
		
		Element result=helper.requestWebService(query,this.endpoint);
		
		return XMLUtils.ElementToString(result);
		
		//return res.getFirstElement();
	}
	
	public String getHitsByMD5BLASTML
	(String md5, String[] taxonInclude, String[] taxonExclude, String[] sources, int min_optscore,
			Double maxEvalue,int maxNumberHits,String[] dbList, boolean show_sequence,boolean show_alignment) throws Exception {
		Hashtable<String,String> options=new Hashtable();
		
		options.put("md5",md5);
	
		options.put("showSequence",new Boolean(show_sequence).toString());
		options.put("showAlignment",new Boolean(show_alignment).toString());
		options.put("maxNumberHits",new Integer(maxNumberHits).toString());
		options.put("maxEvalue",new Double(maxEvalue).toString());
		options.put("minSWScore",new Integer(min_optscore).toString());
		//options.put("dbList",dbList);
		
		Element query=helper.createElement("getHitsByMD5BLASTML",options);
		
		Element dbs=helper.createListElement("DatabaseList","database",dbList);
		query.appendChild(dbs);
		
		Element source_include=helper.createListElement("sourceList","source",sources);
		query.appendChild(source_include);
		
		
		Element tax_include=helper.createListElement("TaxonsInclude","taxId",taxonInclude);
		query.appendChild(tax_include);
		
		Element tax_exclude=helper.createListElement("TaxonsExclude","taxId",taxonExclude);
		
		query.appendChild(tax_exclude);
		
		Element result=helper.requestWebService(query,this.endpoint);
		
		return XMLUtils.ElementToString((Element)result.getFirstChild());
		
		
	}
	
	
}
