package simapclient;


import java.io.StringReader;
import java.math.BigInteger;
import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;
import java.util.ArrayList;
import java.util.Enumeration;
import java.util.Hashtable;
import java.util.Iterator;

import javax.xml.namespace.QName;
import javax.xml.stream.XMLInputFactory;
import javax.xml.stream.XMLOutputFactory;
import javax.xml.stream.XMLStreamReader;
import javax.xml.stream.XMLStreamWriter;

import org.apache.axis2.AxisFault;
import org.apache.axis2.Constants;
import org.apache.axis2.addressing.EndpointReference;
import org.apache.axis2.client.Call;
import org.apache.axis2.client.Options;
import org.apache.axis2.om.OMAbstractFactory;
import org.apache.axis2.om.OMAttribute;
import org.apache.axis2.om.OMElement;
import org.apache.axis2.om.OMFactory;
import org.apache.axis2.om.OMNamespace;
import org.apache.axis2.om.impl.llom.builder.StAXOMBuilder;

public class SimapClientUtil {
	private static EndpointReference targetEPR;
	private static  OMFactory fac;
	private static OMNamespace omNs;
	private static boolean initialized=false;
	
	public static ArrayList fromIterator(Iterator iter){
		ArrayList h=new ArrayList();
		
		while (iter.hasNext()){
			h.add(iter.next());
		}
		return h;
		
	}
	/**
	public String transform(String xml, String o_xsltransform){
		String res="";
		StringWriter transformed_result = new StringWriter();
		try {
			javax.xml.transform.TransformerFactory tFactory = javax.xml.transform.TransformerFactory
					.newInstance();
			javax.xml.transform.Transformer transformer = tFactory
					.newTransformer(new javax.xml.transform.stream.StreamSource(
							o_xsltransform));
			//Document resultdoc=new Document(xml);
			transformer.transform(new JDOMSource(resultdoc),
					new javax.xml.transform.stream.StreamResult(
							transformed_result));
			res = transformed_result.toString();
		} catch (TransformerConfigurationException e1) {
			System.err.println("XSL stylesheet error: "
					+ e1.getMessage());
		} catch (TransformerException e2) {
			System.err.println("XSL transformation error: "
					+ e2.getMessage());
		}
		
		return res;
	}
	**/
	public static void setEndpointReference(String endpoint) {
		 initialize();
		 targetEPR = new EndpointReference(endpoint);
		
	}
	public static void initialize() {
		if (initialized) return;
		fac = OMAbstractFactory.getOMFactory();
        omNs = fac.createOMNamespace(
                "http://mips.gsf.de", "simap");
        targetEPR = new EndpointReference("http://localhost:8080/axis2/services/simap");
        initialized=true;
		
	}
	public static ArrayList IntArraytoArray(int[] h){
		ArrayList r=new ArrayList();
		for (int i=0;i<h.length;i++) r.add(new Integer(h[i]));
		return r;
	}
	public static OMElement getOMElementFromXML(String xml) throws Exception {
		StringReader str=new StringReader(xml);
		
		XMLInputFactory xif = XMLInputFactory.newInstance();
		XMLStreamReader reader = xif.createXMLStreamReader(str);
		StAXOMBuilder builder = new StAXOMBuilder(reader);
		return builder.getDocumentElement();
		
	}
	//TODO return as String instead of printing out .... 
	public static String formatXML(OMElement a) throws Exception {
		StringBuffer buffer=new StringBuffer();
		 XMLOutputFactory xof = XMLOutputFactory.newInstance();
		   XMLStreamWriter writer = xof.
		      createXMLStreamWriter(System.out);
		      a.serialize(writer);
		      writer.flush();
		return buffer.toString();
	}
	
	public static OMElement multipleParameter(String name1,String name2, String[] values){
		OMElement multiple=getSimapElement(name1);
		for (int i=0;i<values.length;i++){
			String cur=values[i];
			OMElement m=getSimapElement(name2,cur);
			multiple.addChild(m);
		}
		
		return multiple;
		
	}
	public static OMElement ServiceQuery(String method,Hashtable<String,String> arguments){
		OMElement res=getSimapElement(method,"");
		// missing list types, but probably not neeed
		Enumeration<String> keys=arguments.keys();
		while (keys.hasMoreElements()){
			String name=keys.nextElement();
			OMElement cur=getSimapElement(name,arguments.get(name));
			res.addChild(cur);
		}
		
		return res;
	}
	
	public static OMElement ServiceQuery(String method, OMElement attributes){
		OMElement res=getSimapElement(method,"");
		if (!(attributes==null)) res.addChild(attributes);
		return res;
	}
	
		public static String arrayToString(Object[] h){
			StringBuffer r=new StringBuffer();
			for (int i=0;i<h.length;i++) r.append(h[i].toString() + "\n");
			return r.toString();
			
		}
	 public static OMElement getSimapElement(String attribute,String value) {
	        
	        initialize();
	        OMElement m = fac.createOMElement(attribute, omNs);
	        m.setText(value);
	        return m;
	    }
	public static OMElement getSimapElement(String method) {
        
        initialize();
        OMElement m = fac.createOMElement(method, omNs);
        return m;
    }
	
	public static ArrayList<OMElement> getChildList(OMElement xml){
		ArrayList<OMElement> res=new ArrayList();
		return SimapClientUtil.fromIterator(xml.getChildElements());
		
	}
    
 public static QName getSimapName(String name) {
        
        initialize();
        QName m = new QName(name);
        
        return m;
    }
public static OMAttribute getSimapAttribute(String method, String value) {
        
        initialize();
        OMAttribute m = fac.createOMAttribute(method, omNs, value);
        return m;
    }
    public static void setQuery(OMElement myElement, String option,String value){
    	OMElement method = fac.createOMElement(option, omNs);
    	method.setText(value);
    	myElement.addChild(method);
    	
    }
    
   
    public static String prettyPrintXML(OMElement e,int level){
    	StringBuffer b=new StringBuffer();
    	Iterator iter;
    	
    	if (level==0){
//    		 root-element	
    		ArrayList dummy=new ArrayList();
    		dummy.add(e);
    		iter=dummy.iterator();
    	} else {
    		
    		iter=e.getChildElements();
    	}
    	while (iter.hasNext()){
    		b.append("\n");
    		OMElement cur=(OMElement)iter.next();
    		b.append(getIndent(level));
    		b.append("<"+cur.getLocalName()+">");
    		b.append(cur.getText());
    		b.append(prettyPrintXML(cur,level+1));
    		if (cur.getText().equals("")) b.append(getIndent(level));
    		b.append("</"+cur.getLocalName()+">");
    		
    		
    		
    	}
    
    	return b.toString();
    }
	
	public static Hashtable makeHash(OMElement element){
		
		element.build();
		Hashtable options =new Hashtable();
		
		Iterator iter;
		// commented out in order to ensure correct parameters for web-services
		// only child elements are options !!!
		//options.put(element.getLocalName(),element.getText());
        
		iter=element.getChildElements();
        
        while (iter.hasNext()){
        	OMElement d=(OMElement)iter.next();
        	Iterator iter2=d.getChildElements();
        	ArrayList multiple=new ArrayList();
        	while (iter2.hasNext()){
        		multiple.add(iter2.next());
        	}
        	if (multiple.size()>0) {
        		
        		Iterator it=multiple.iterator();
        		ArrayList x=new ArrayList();
        		while (it.hasNext()){
        			OMElement cur=(OMElement)it.next();
        			x.add(cur.getText());
        			
        		}
        		String q=d.getLocalName();
        		options.put(q,x);
        	} else {
        		
        	String q=d.getLocalName();
        	String v=d.getText();
        	options.put(q,v);
        	}
        }	
        
		
		return options;
	}
		
	public static String computeMD5Hash(String sequence) throws Exception
	//	compute MD5 Hash
	{
		//Get md5 digest of the sequence
		MessageDigest md5 = null;
		try {
			md5 = MessageDigest.getInstance("MD5");
		} catch (NoSuchAlgorithmException e) {
			throw new Exception("MD5 digest algorithm unavailable.");
			
		}
		md5.update(sequence.toUpperCase().getBytes());
		BigInteger md5hash = new BigInteger(1, md5.digest());
		String sequence_md5 = md5hash.toString(16);
		// leading zeros are added to make a 32 digit String
		while (sequence_md5.length() < 32) {
			sequence_md5 = "0" + sequence_md5;
		}
		return sequence_md5;
	}
	private static String getIndent(int r){String h=""; for (int i=0;i<r;i++){h+="\t";} return h;}
}
