package simapclient;
import java.net.URL;
import java.util.ArrayList;
import java.util.Enumeration;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.Vector;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;

import org.apache.axis.client.Call;
import org.apache.axis.client.Service;
import org.apache.axis.message.SOAPBodyElement;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

public class SimapHelper   {
	private String proxyhost;
	private String proxyport;
	private boolean proxy=false;
	private Document doc;
	private DocumentBuilder builder;
	private String namespace;
	
	public void setProxy(String host,String port){
		this.proxy=true;
		this.proxyhost=host;
		this.proxyport=port;
		
	}
	public static ArrayList fromIterator(Iterator iter){
		ArrayList h=new ArrayList();
		
		while (iter.hasNext()){
			h.add(iter.next());
		}
		return h;
		
	}
	public SimapHelper(String namesapce) throws Exception{
        builder = DocumentBuilderFactory.newInstance().newDocumentBuilder();
        doc = builder.newDocument();
        this.namespace=namespace;
		
	}
	public  Element createElement (String name){
		
		return doc.createElementNS(this.namespace,name);
	}
	
	public Node creatreTextNode(String text){
		Node parameter;
        parameter = doc.createTextNode(text);
        return parameter;
		
	}
	
	
	public Element requestWebService(Element req, String targetEndpoint) throws Exception {
		Service  service = new Service();
        Call     call    = (Call) service.createCall();
        if (proxy){
        System.setProperty("http.proxySet", "true");
        System.setProperty("http.proxyHost", proxyhost);
        System.setProperty("http.proxyPort", proxyport);
        }
        // 1.2 ... an define the endpoint (service address)
        call.setTargetEndpointAddress( new URL(targetEndpoint) );
		  SOAPBodyElement[] request = new SOAPBodyElement[1];
	        // 3.2 ... and we add to this our request document
	        request[0] = new SOAPBodyElement(req);
	        // System.out.println(input[0].toString()); print it if you want
	        // 3.3 And now the real invocation
	        //System.out.println(req);
	        Vector resultVector = (Vector) call.invoke( request );


	        // 4. Extracting the result document
	        // 4.1 Wrapped document style web services will return only one document
	        SOAPBodyElement resultElements = (SOAPBodyElement) resultVector.get(0);
	        // 4.2 We convert it to a DOM object for later processing
	        Element resultElement  = resultElements.getAsDOM();
	        return resultElement;
		
	}
	
	public Element createListElement(String name,String name2,Object[] elem){
		Element basis=this.createElement(name);
		for (Object e : elem){
			Element basis2=this.createElement(name2);
			basis2.setTextContent(e.toString());
			basis.appendChild(basis2);
		}
		return basis;
	}
	
	public Element createElement(String name,Hashtable fields){
		Element basis=this.createElement(name);
		Enumeration k=fields.keys();
		ArrayList dummy=new ArrayList();
		while (k.hasMoreElements()){
			
			Object mykey=k.nextElement();
			Object myvalue=fields.get(mykey);
			
			// have we an array-list ?
			if (myvalue.getClass().equals(dummy.getClass())){
				
				ArrayList d=(ArrayList)myvalue;
				for (Object hase : d) {
				Element myelement=this.createElement(mykey.toString());
				
					Node mynode=this.creatreTextNode(hase.toString());
					myelement.appendChild(mynode);
				
				basis.appendChild(myelement);
				}
			} else {
				Element myelement=this.createElement(mykey.toString());
				Node mynode=this.creatreTextNode(myvalue.toString());
				myelement.appendChild(mynode);
				basis.appendChild(myelement);
				
			}
			
		}
		
		return basis;
		
	}
	
	public Hashtable createHash(Element e){
		Hashtable res=new Hashtable();
		NodeList w=e.getChildNodes();
		int u=w.getLength();
		for (int i=0;i<u;i++){
			Element cur=(Element)w.item(i);
			String name=cur.getLocalName();
			String value=cur.getTextContent();
			res.put(name,value);
		}
		return res;
	}
}
