package simapclient;



import org.jdom.Element;

public interface SingleSequence {

	/**
	 * @return sequenceid
	 */
	public abstract int getSequenceID();

	/**
	 * @return MD5 fingerprint
	 */
	public abstract String getMD5();

	/**
	 * @return CRC64 fingerprint
	 */
	public abstract String getCRC64();

	/**
	 * @return length
	 */
	public abstract int getLength();

	/**
	 * @return selfscore
	 */
	public abstract int getSelfscore();

	/**
	 * @return status
	 */
	public abstract int getStatus();

	/**
	 * @return number of hits
	 */
	public abstract int getNumberHits();

	/**
	 * @return amino acid sequence
	 */
	public abstract String getSequence();

	/**
	 * @param ESequence
	 * @param add_sequence Add amino acid sequence?
	 * Adds XML elements describing the sequence to ESequence
	 */
	public abstract void addXML(Element ESequence, boolean add_sequence);

	/**
	 * @param width
	 * @return pretty formatted sequence
	 */
	public abstract String getPrettySequence(int width);

	/**
	 * @param width
	 * @return fasta formatted sequence
	 */
	public abstract String getFastaSequence(int width);

}